diff -Naur --exclude=CVS --exclude=configs linux/include/asm-generic/smplock.h linux-openmosix/include/asm-generic/smplock.h
--- linux/include/asm-generic/smplock.h	2000-03-23 21:50:09.000000000 +0100
+++ linux-openmosix/include/asm-generic/smplock.h	2004-02-05 10:51:23.000000000 +0100
@@ -49,3 +49,24 @@
 	if (--current->lock_depth < 0)
 		spin_unlock(&kernel_flag);
 }
+
+#ifdef CONFIG_MOSIX
+
+/* the big MOSIX lock resembles the big kernel lock in the way it is
+ * allowed to be locked multiple times.  It is not allowed, however,
+ * to remain locked when entering "schedule".
+ */
+extern spinlock_t mosix_flag;
+
+extern __inline__ void lock_mosix(void)
+{
+	if (!++current->mosix.lock_depth)
+		spin_lock(&mosix_flag);
+}
+
+extern __inline__ void unlock_mosix(void)
+{
+	if (--current->mosix.lock_depth < 0)
+		spin_unlock(&mosix_flag);
+}
+#endif /* CONFIG_MOSIX */
diff -Naur --exclude=CVS --exclude=configs linux/include/asm-i386/a.out.h linux-openmosix/include/asm-i386/a.out.h
--- linux/include/asm-i386/a.out.h	1995-06-16 20:33:06.000000000 +0200
+++ linux-openmosix/include/asm-i386/a.out.h	2004-02-05 10:51:24.000000000 +0100
@@ -21,6 +21,9 @@
 
 #define STACK_TOP	TASK_SIZE
 
+#ifdef CONFIG_MOSIX
+void aout_remote_init_mm(struct exec *);
+#endif /* CONFIG_MOSIX */
 #endif
 
 #endif /* __A_OUT_GNU_H__ */
diff -Naur --exclude=CVS --exclude=configs linux/include/asm-i386/checksum.h linux-openmosix/include/asm-i386/checksum.h
--- linux/include/asm-i386/checksum.h	2003-11-28 19:26:21.000000000 +0100
+++ linux-openmosix/include/asm-i386/checksum.h	2004-02-05 10:51:24.000000000 +0100
@@ -1,6 +1,13 @@
 #ifndef _I386_CHECKSUM_H
 #define _I386_CHECKSUM_H
 
+#ifndef CONFIG_MOSIX
+#include <linux/config.h>
+#endif /* CONFIG_MOSIX */
+
+#ifdef CONFIG_MOSIX
+#include <asm/uaccess.h>
+#endif /* CONFIG_MOSIX */
 
 /*
  * computes the checksum of a memory block at buff, length len,
@@ -38,13 +45,29 @@
 unsigned int csum_partial_copy_nocheck ( const char *src, char *dst,
 					int len, int sum)
 {
+#ifdef CONFIG_MOSIX
+	if(!segment_eq(get_fs(), KERNEL_DS) &&
+		(((unsigned long)src) < PAGE_OFFSET ||
+		((unsigned long)dst) < PAGE_OFFSET))
+		panic("csum_partial_copy_nocheck, src=%x,dst=%x",(int)src,(int)dst);
+#endif /* CONFIG_MOSIX */
 	return csum_partial_copy_generic ( src, dst, len, sum, NULL, NULL);
 }
 
+#ifdef CONFIG_MOSIX
+extern unsigned int deputy_csum_partial_copy_from_user(const char *, char *, int, int, int *);
+extern unsigned int deputy_csum_partial_copy_to_user(const char *, char *, int, int, int *);
+#endif /* CONFIG_MOSIX */
+
 static __inline__
 unsigned int csum_partial_copy_from_user ( const char *src, char *dst,
 						int len, int sum, int *err_ptr)
 {
+#ifdef CONFIG_MOSIX
+	if(memory_not_here(len, FROM_USER))
+		return(deputy_csum_partial_copy_from_user(src, dst, len,
+								sum, err_ptr));
+#endif /* CONFIG_MOSIX */
 	return csum_partial_copy_generic ( src, dst, len, sum, err_ptr, NULL);
 }
 
@@ -184,6 +207,11 @@
 static __inline__ unsigned int csum_and_copy_to_user(const char *src, char *dst,
 				    int len, int sum, int *err_ptr)
 {
+#ifdef CONFIG_MOSIX
+	if(memory_not_here(len, FROM_USER))
+		return(deputy_csum_partial_copy_to_user(src, dst, len,
+								sum, err_ptr));
+#endif /* CONFIG_MOSIX */
 	if (access_ok(VERIFY_WRITE, dst, len))
 		return csum_partial_copy_generic(src, dst, len, sum, NULL, err_ptr);
 
diff -Naur --exclude=CVS --exclude=configs linux/include/asm-i386/cpufeature.h linux-openmosix/include/asm-i386/cpufeature.h
--- linux/include/asm-i386/cpufeature.h	2003-11-28 19:26:21.000000000 +0100
+++ linux-openmosix/include/asm-i386/cpufeature.h	2004-02-05 10:51:24.000000000 +0100
@@ -101,6 +101,22 @@
 #define cpu_has_centaur_mcr	boot_cpu_has(X86_FEATURE_CENTAUR_MCR)
 #define cpu_has_xstore		boot_cpu_has(X86_FEATURE_XSTORE)
 
+#ifdef CONFIG_MOSIX
+#define	FBIT(feature)	(1 << ((feature) % 32))
+#define	USER_MODE_FEATURES0	(FBIT(X86_FEATURE_TSC)|FBIT(X86_FEATURE_CX8)|\
+				FBIT(X86_FEATURE_SEP)|FBIT(X86_FEATURE_CMOV)|\
+				FBIT(X86_FEATURE_MMX)|FBIT(X86_FEATURE_CLFLSH)|\
+				FBIT(X86_FEATURE_FXSR)|FBIT(X86_FEATURE_XMM)|\
+				FBIT(X86_FEATURE_XMM2))
+#define	USER_MODE_FEATURES1	(FBIT(X86_FEATURE_SYSCALL)|\
+				FBIT(X86_FEATURE_MMXEXT)|FBIT(X86_FEATURE_LM)|\
+				FBIT(X86_FEATURE_3DNOWEXT)|\
+				FBIT(X86_FEATURE_3DNOW))
+#define	USER_MODE_FEATURES2	0
+#define	USER_MODE_FEATURES3	(FBIT(X86_FEATURE_CXMMX))
+#define	USER_MODE_FEATURES	{ USER_MODE_FEATURES0, USER_MODE_FEATURES1, \
+				USER_MODE_FEATURES2, USER_MODE_FEATURES3 }
+#endif /* CONFIG_MOSIX */
 #endif /* __ASM_I386_CPUFEATURE_H */
 
 /* 
diff -Naur --exclude=CVS --exclude=configs linux/include/asm-i386/elf.h linux-openmosix/include/asm-i386/elf.h
--- linux/include/asm-i386/elf.h	2003-11-28 19:26:21.000000000 +0100
+++ linux-openmosix/include/asm-i386/elf.h	2004-02-05 10:51:24.000000000 +0100
@@ -41,6 +41,12 @@
    We might as well make sure everything else is cleared too (except for %esp),
    just to make things more deterministic.
  */
+#ifdef CONFIG_MOSIX
+#define	ELF_PLAT_INIT_REGS	(BIT_OF_REGISTER(ebx)|BIT_OF_REGISTER(ecx)|\
+				 BIT_OF_REGISTER(edx)|BIT_OF_REGISTER(esi)|\
+				 BIT_OF_REGISTER(edi)|BIT_OF_REGISTER(ebp)|\
+				 BIT_OF_REGISTER(eax))
+#endif /* CONFIG_MOSIX */
 #define ELF_PLAT_INIT(_r, load_addr)	do { \
 	_r->ebx = 0; _r->ecx = 0; _r->edx = 0; \
 	_r->esi = 0; _r->edi = 0; _r->ebp = 0; \
diff -Naur --exclude=CVS --exclude=configs linux/include/asm-i386/fcntl.h linux-openmosix/include/asm-i386/fcntl.h
--- linux/include/asm-i386/fcntl.h	2001-09-17 22:16:30.000000000 +0200
+++ linux-openmosix/include/asm-i386/fcntl.h	2004-02-05 10:51:24.000000000 +0100
@@ -21,6 +21,10 @@
 #define O_DIRECTORY	0200000	/* must be a directory */
 #define O_NOFOLLOW	0400000 /* don't follow links */
 
+#ifdef CONFIG_MOSIX
+#define	O_NOWRITEACCESS	01000000 /* do not put_write_access() */
+#endif /* CONFIG_MOSIX */
+
 #define F_DUPFD		0	/* dup */
 #define F_GETFD		1	/* get close_on_exec */
 #define F_SETFD		2	/* set/clear close_on_exec */
diff -Naur --exclude=CVS --exclude=configs linux/include/asm-i386/i387.h linux-openmosix/include/asm-i386/i387.h
--- linux/include/asm-i386/i387.h	2002-08-03 02:39:45.000000000 +0200
+++ linux-openmosix/include/asm-i386/i387.h	2004-02-05 10:51:24.000000000 +0100
@@ -86,4 +86,10 @@
 extern int dump_extended_fpu( struct pt_regs *regs,
 			      struct user_fxsr_struct *fpu );
 
+#ifdef CONFIG_MOSIX
+extern int has_fxsr(void);
+extern void fsave_to_fxsave(union i387_union *, union i387_union *);
+extern void fxsave_to_fsave(union i387_union *, union i387_union *);
+#endif /* CONFIG_MOSIX */
+
 #endif /* __ASM_I386_I387_H */
diff -Naur --exclude=CVS --exclude=configs linux/include/asm-i386/processor.h linux-openmosix/include/asm-i386/processor.h
--- linux/include/asm-i386/processor.h	2003-08-25 13:44:43.000000000 +0200
+++ linux-openmosix/include/asm-i386/processor.h	2004-02-05 10:51:24.000000000 +0100
@@ -415,6 +415,12 @@
 	regs->esp = new_esp;					\
 } while (0)
 
+#ifdef CONFIG_MOSIX
+#define START_THREAD_REGS (BIT_OF_REGISTER(xds)|BIT_OF_REGISTER(xes)|\
+			   BIT_OF_REGISTER(xss)|BIT_OF_REGISTER(xcs)|\
+			   BIT_OF_REGISTER(eip)|BIT_OF_REGISTER(esp))
+#endif /* CONFIG_MOSIX */
+
 /* Forward declaration, a strange C thing */
 struct task_struct;
 struct mm_struct;
@@ -425,6 +431,10 @@
  * create a kernel thread without removing it from tasklists
  */
 extern int arch_kernel_thread(int (*fn)(void *), void * arg, unsigned long flags);
+#ifdef CONFIG_MOSIX
+extern int arch_user_thread(int (*fn)(void *), void * arg, unsigned long flags);
+#endif /* CONFIG_MOSIX */
+
 
 /* Copy and release all segment info associated with a VM */
 extern void copy_segments(struct task_struct *p, struct mm_struct * mm);
@@ -439,8 +449,13 @@
 }
 
 unsigned long get_wchan(struct task_struct *p);
+#ifdef CONFIG_MOSIX
+#define	KSTK_EIP(tsk)	(mos_to_regs(&(tsk)->mosix)->eip)
+#define	KSTK_ESP(tsk)	(mos_to_regs(&(tsk)->mosix)->esp)
+#else
 #define KSTK_EIP(tsk)	(((unsigned long *)(4096+(unsigned long)(tsk)))[1019])
 #define KSTK_ESP(tsk)	(((unsigned long *)(4096+(unsigned long)(tsk)))[1022])
+#endif /* CONFIG_MOSIX */
 
 #define THREAD_SIZE (2*PAGE_SIZE)
 #define alloc_task_struct() ((struct task_struct *) __get_free_pages(GFP_KERNEL,1))
diff -Naur --exclude=CVS --exclude=configs linux/include/asm-i386/rwsem.h linux-openmosix/include/asm-i386/rwsem.h
--- linux/include/asm-i386/rwsem.h	2002-11-29 00:53:15.000000000 +0100
+++ linux-openmosix/include/asm-i386/rwsem.h	2004-02-05 10:51:24.000000000 +0100
@@ -6,6 +6,8 @@
  *
  * Trylock by Brian Watson (Brian.J.Watson@compaq.com).
  *
+ * Trylock by Brian Watson 
+ * 
  *
  * The MSW of the count is the negated number of active writers and waiting
  * lockers, and the LSW is the total number of active locks
@@ -62,7 +64,7 @@
 #define RWSEM_ACTIVE_WRITE_BIAS		(RWSEM_WAITING_BIAS + RWSEM_ACTIVE_BIAS)
 	spinlock_t		wait_lock;
 	struct list_head	wait_list;
-#if RWSEM_DEBUG
+#if RWSEM_DEBUG /* to be removed shortly */ 
 	int			debug;
 #endif
 };
@@ -73,7 +75,7 @@
 #if RWSEM_DEBUG
 #define __RWSEM_DEBUG_INIT      , 0
 #else
-#define __RWSEM_DEBUG_INIT	/* */
+#define __RWSEM_DEBUG_INIT	
 #endif
 
 #define __RWSEM_INITIALIZER(name) \
diff -Naur --exclude=CVS --exclude=configs linux/include/asm-i386/semaphore.h linux-openmosix/include/asm-i386/semaphore.h
--- linux/include/asm-i386/semaphore.h	2002-11-29 00:53:15.000000000 +0100
+++ linux-openmosix/include/asm-i386/semaphore.h	2004-02-05 10:51:24.000000000 +0100
@@ -159,6 +159,11 @@
 	return result;
 }
 
+#ifdef CONFIG_MOSIX
+/* do not be interrupted by signals, but still respond to MOSIX requests */
+extern void down_half_interruptible(struct semaphore *);
+#endif /* CONFIG_MOSIX */
+
 /*
  * Non-blockingly attempt to down() a semaphore.
  * Returns zero if we acquired it
diff -Naur --exclude=CVS --exclude=configs linux/include/asm-i386/siginfo.h linux-openmosix/include/asm-i386/siginfo.h
--- linux/include/asm-i386/siginfo.h	2002-08-03 02:39:45.000000000 +0200
+++ linux-openmosix/include/asm-i386/siginfo.h	2004-02-05 10:51:24.000000000 +0100
@@ -59,6 +59,12 @@
 			int _band;	/* POLL_IN, POLL_OUT, POLL_MSG */
 			int _fd;
 		} _sigpoll;
+#ifdef CONFIG_MOSIX
+		struct {
+			int _newplace;
+			int _reason;
+		} _sigmig;
+#endif /* CONFIG_MOSIX */
 	} _sifields;
 } siginfo_t;
 
@@ -76,6 +82,10 @@
 #define si_addr		_sifields._sigfault._addr
 #define si_band		_sifields._sigpoll._band
 #define si_fd		_sifields._sigpoll._fd
+#ifdef CONFIG_MOSIX
+#define	si_newplace	_sifields._sigmig._newplace
+#define	si_reason	_sifields._sigmig._reason
+#endif /* CONFIG_MOSIX */
 
 #ifdef __KERNEL__
 #define __SI_MASK	0xffff0000
@@ -85,6 +95,9 @@
 #define __SI_FAULT	(3 << 16)
 #define __SI_CHLD	(4 << 16)
 #define __SI_RT		(5 << 16)
+#ifdef CONFIG_MOSIX
+#define	__SI_MIGRATION	(6 << 16)
+#endif /* CONFIG_MOSIX */
 #define __SI_CODE(T,N)	((T) << 16 | ((N) & 0xffff))
 #else
 #define __SI_KILL	0
@@ -108,6 +121,9 @@
 #define SI_ASYNCIO	-4		/* sent by AIO completion */
 #define SI_SIGIO	-5		/* sent by queued SIGIO */
 #define SI_TKILL	-6		/* sent by tkill system call */
+#ifdef CONFIG_MOSIX
+#define	SI_MIGRATION	0x100	        /* sent by migration */
+#endif /* CONFIG_MOSIX */
 
 #define SI_FROMUSER(siptr)	((siptr)->si_code <= 0)
 #define SI_FROMKERNEL(siptr)	((siptr)->si_code > 0)
@@ -182,6 +198,10 @@
 #define POLL_HUP	(__SI_POLL|6)	/* device disconnected */
 #define NSIGPOLL	6
 
+#ifdef CONFIG_MOSIX
+#define	SI_MIGRATED	(__SI_MIGRATION|1)	/* process migrated */
+#endif /* CONFIG_MOSIX */
+
 /*
  * sigevent definitions
  * 
diff -Naur --exclude=CVS --exclude=configs linux/include/asm-i386/smplock.h linux-openmosix/include/asm-i386/smplock.h
--- linux/include/asm-i386/smplock.h	2003-06-13 16:51:38.000000000 +0200
+++ linux-openmosix/include/asm-i386/smplock.h	2004-02-05 10:51:24.000000000 +0100
@@ -78,4 +78,27 @@
 #endif
 }
 
+#ifdef CONFIG_MOSIX
+
+/* the big MOSIX lock resembles the big kernel lock in the way it is
+    + * allowed to be locked multiple times.  It is not allowed, however,
+    + * to remain locked when entering "schedule".
+    + */
+extern spinlock_t mosix_flag;
+
+extern __inline__ void lock_mosix(void)
+{
+       if (!++current->mosix.lock_depth)
+		spin_lock(&mosix_flag);
+}
+
+extern __inline__ void unlock_mosix(void)
+{
+	if (current->mosix.lock_depth < 0)
+		BUG();
+	if (--current->mosix.lock_depth < 0)
+		spin_unlock(&mosix_flag);
+}
+#endif /* CONFIG_MOSIX */
+
 #endif /* __ASM_SMPLOCK_H */
diff -Naur --exclude=CVS --exclude=configs linux/include/asm-i386/spinlock.h linux-openmosix/include/asm-i386/spinlock.h
--- linux/include/asm-i386/spinlock.h	2002-11-29 00:53:15.000000000 +0100
+++ linux-openmosix/include/asm-i386/spinlock.h	2004-02-05 10:51:24.000000000 +0100
@@ -209,4 +209,8 @@
 	return 0;
 }
 
+#ifdef CONFIG_MOSIX
+#define can_read_lock(rw)	((rw)->lock > 0)
+#endif /* CONFIG_MOSIX */
+
 #endif /* __ASM_SPINLOCK_H */
diff -Naur --exclude=CVS --exclude=configs linux/include/asm-i386/stat.h linux-openmosix/include/asm-i386/stat.h
--- linux/include/asm-i386/stat.h	2000-08-01 23:08:00.000000000 +0200
+++ linux-openmosix/include/asm-i386/stat.h	2004-02-05 10:51:24.000000000 +0100
@@ -75,4 +75,12 @@
 	unsigned long long	st_ino;
 };
 
+#ifdef CONFIG_MOSIX_FS
+
+/* more information about MFS: */
+#define STAT64_NODE(_x)		(*((short *)(&(_x).__pad0[2])))
+#define STAT64_ORIGDEV(_x)	(*((short *)(&(_x).__pad0[4])))
+#define STAT64_ORIGINO(_x)	(*((unsigned long *)(&(_x).__pad0[6])))
+
+#endif /* CONFIG_MOSIX_FS */
 #endif
diff -Naur --exclude=CVS --exclude=configs linux/include/asm-i386/uaccess.h linux-openmosix/include/asm-i386/uaccess.h
--- linux/include/asm-i386/uaccess.h	2003-06-13 16:51:38.000000000 +0200
+++ linux-openmosix/include/asm-i386/uaccess.h	2004-02-05 10:51:24.000000000 +0100
@@ -32,6 +32,75 @@
 
 #define segment_eq(a,b)	((a).seg == (b).seg)
 
+#ifdef CONFIG_MOSIX
+
+enum { FROM_USER, TO_USER };
+
+#define	COPY_COUNTER_MULTIPLIER	1024
+#define	COPY_COUNTER_SHIFT	10
+
+static inline void
+mosix_local_statistic(int __nb, int __dir)
+{
+	extern void cause_link_error_by_routine_that_does_not_exist(void);
+
+	if(__dir == TO_USER)
+	{
+#ifdef CONFIG_MOSIX_DFSA
+		if(current->mosix.dflags & DSTATSDOWN)
+			return;
+#endif /* CONFIG_MOSIX_DFSA */
+		current->mosix.ncopyouts += COPY_COUNTER_MULTIPLIER;
+		current->mosix.copyoutbytes += __nb;
+	}
+	else if(__dir == FROM_USER)
+	{
+#ifdef CONFIG_MOSIX_DFSA
+		if(current->mosix.dflags & DSTATSDOWN)
+		{
+			current->mosix.copy_ins++;
+			current->mosix.bytes_in += __nb;
+		}
+		else
+#endif /* CONFIG_MOSIX_DFSA */
+		{
+			current->mosix.ncopyins += COPY_COUNTER_MULTIPLIER;
+			current->mosix.copyinbytes += __nb;
+		}
+	}
+	else	/* impossible:  look here to fix gcc 3.x problems*/
+          /*   cause_link_error_by_routine_that_does_not_exist(); */
+	panic("openMosix: You should never get this message! (gcc problem)\n");
+}
+
+#define	USER_IS_REMOTE	((current->mosix.dflags & DDEPUTY) && \
+			 segment_eq(get_fs(), USER_DS))
+
+static inline int
+memory_not_here(int bytes, int direction)
+{
+	if(segment_eq(get_fs(), KERNEL_DS))
+		return(0);
+	switch(current->mosix.dflags & (DDEPUTY|DREMOTE))
+	{
+		case DDEPUTY:
+			return(1);
+		default:
+			mosix_local_statistic(bytes, direction);
+			/* fall thru */
+		case DREMOTE:
+			return(0);
+	}
+}
+
+extern unsigned long deputy_copy_from_user(void *, void *, unsigned long, int);
+extern unsigned long deputy_copy_to_user(void *, void *, unsigned long, int);
+extern unsigned long deputy_clear_user(void *, int, int);
+extern long deputy_strncpy_from_user(char *, char *, int, int);
+extern long deputy_strnlen_user(char *, long);
+extern int deputy_verify_write(void *, unsigned long);
+#endif /* CONFIG_MOSIX */
+
 extern int __verify_write(const void *, unsigned long);
 
 #define __addr_ok(addr) ((unsigned long)(addr) < (current->addr_limit.seg))
@@ -172,6 +241,23 @@
  * Returns zero on success, or -EFAULT on error.
  * On error, the variable @x is set to zero.
  */
+#ifdef CONFIG_MOSIX
+#define get_user(x,ptr)							\
+({	int __ret_gu,__val_gu;                                          \
+	if(memory_not_here(sizeof(*(ptr)),FROM_USER))                   \
+		__ret_gu = deputy_copy_from_user((void *)&__val_gu,     \
+			(void *)ptr, sizeof(*(ptr)), 1);                \
+	else                                                            \
+	switch(sizeof (*(ptr))) {                                       \
+	case 1:  __get_user_x(1,__ret_gu,__val_gu,ptr); break;          \
+	case 2:  __get_user_x(2,__ret_gu,__val_gu,ptr); break;          \
+	case 4:  __get_user_x(4,__ret_gu,__val_gu,ptr); break;          \
+	default: __get_user_x(X,__ret_gu,__val_gu,ptr); break;          \
+	}                                                               \
+	(x) = (__typeof__(*(ptr)))__val_gu;                             \
+	__ret_gu;                                                       \
+})
+#else
 #define get_user(x,ptr)							\
 ({	int __ret_gu,__val_gu;						\
 	switch(sizeof (*(ptr))) {					\
@@ -183,6 +269,7 @@
 	(x) = (__typeof__(*(ptr)))__val_gu;				\
 	__ret_gu;							\
 })
+#endif /* CONFIG_MOSIX */
 
 extern void __put_user_1(void);
 extern void __put_user_2(void);
@@ -208,6 +295,36 @@
  *
  * Returns zero on success, or -EFAULT on error.
  */
+
+#ifdef CONFIG_MOSIX
+#define put_user(x,ptr)							\
+({	int __ret_pu;							\
+	if(memory_not_here(sizeof(*(ptr)),TO_USER)) {			\
+		__typeof__(*(ptr)) __val_pu = (__typeof__(*ptr)) x;	\
+		__ret_pu = deputy_copy_to_user((void *)ptr,		\
+			(void *)&__val_pu, sizeof(*(ptr)), 1); }	\
+	else								\
+		__ret_pu =						\
+  __put_user_nocheck((__typeof__(*(ptr)))(x),(ptr),sizeof(*(ptr)));	\
+	__ret_pu;							\
+})
+
+#define __get_user(x,ptr) \
+	(memory_not_here(sizeof(*(ptr)),FROM_USER) ?			\
+		({ int __ret_gu,__val_gu;				\
+		__ret_gu = deputy_copy_from_user((void *)&__val_gu,	\
+			(void *)(ptr), sizeof(*(ptr)), 0);		\
+		(x) = (__typeof__(*(ptr)))__val_gu;			\
+		__ret_gu; })						\
+	: __get_user_nocheck((x),(ptr),sizeof(*(ptr))))
+#define __put_user(x,ptr) \
+	(memory_not_here(sizeof(*ptr),TO_USER) ? ({			\
+		__typeof__(*(ptr)) __val_pu = (__typeof__(*ptr)) x;	\
+		deputy_copy_to_user((void *)(ptr),			\
+			(void *)&__val_pu, sizeof(*(ptr)), 0); })	\
+	: __put_user_nocheck((__typeof__(*(ptr)))(x),(ptr),sizeof(*(ptr))))
+#else
+
 #define put_user(x,ptr)							\
   __put_user_check((__typeof__(*(ptr)))(x),(ptr),sizeof(*(ptr)))
 
@@ -257,6 +374,7 @@
  */
 #define __put_user(x,ptr) \
   __put_user_nocheck((__typeof__(*(ptr)))(x),(ptr),sizeof(*(ptr)))
+#endif /* CONFIG_MOSIX */
 
 #define __put_user_nocheck(x,ptr,size)			\
 ({							\
@@ -708,6 +826,35 @@
  * Returns number of bytes that could not be copied.
  * On success, this will be zero.
  */
+#ifdef CONFIG_MOSIX
+#define copy_to_user(to,from,n)				\
+	(memory_not_here((n),TO_USER) ?			\
+		deputy_copy_to_user((to),(void *)(from),(n),1) : \
+	 __builtin_constant_p(n) ?			\
+	 __constant_copy_to_user((to),(from),(n)) :	\
+	 __generic_copy_to_user((to),(from),(n)))
+
+#define copy_from_user(to,from,n)			\
+	(memory_not_here((n),FROM_USER) ?		\
+		deputy_copy_from_user((to),(void *)(from),(n),1) : \
+	 __builtin_constant_p(n) ?			\
+	 __constant_copy_from_user((to),(from),(n)) :	\
+	 __generic_copy_from_user((to),(from),(n)))
+
+#define __copy_to_user(to,from,n)			\
+	 (memory_not_here((n),TO_USER) ?		\
+		deputy_copy_to_user((to),(void *)(from),(n),0) : \
+	 __builtin_constant_p(n) ?			\
+	 __constant_copy_to_user_nocheck((to),(from),(n)) :	\
+	 __generic_copy_to_user_nocheck((to),(from),(n)))
+
+#define __copy_from_user(to,from,n)			\
+	 (memory_not_here((n),FROM_USER) ?		\
+		deputy_copy_from_user((to),(void *)(from),(n),0) : \
+	 __builtin_constant_p(n) ?			\
+	 __constant_copy_from_user_nocheck((to),(from),(n)) :	\
+	 __generic_copy_from_user_nocheck((to),(from),(n)))
+#else
 #define copy_to_user(to,from,n)				\
 	(__builtin_constant_p(n) ?			\
 	 __constant_copy_to_user((to),(from),(n)) :	\
@@ -774,6 +921,7 @@
 	(__builtin_constant_p(n) ?			\
 	 __constant_copy_from_user_nocheck((to),(from),(n)) :	\
 	 __generic_copy_from_user_nocheck((to),(from),(n)))
+#endif /* CONFIG_MOSIX */
 
 long strncpy_from_user(char *dst, const char *src, long count);
 long __strncpy_from_user(char *dst, const char *src, long count);
diff -Naur --exclude=CVS --exclude=configs linux/include/hpc/balance.h linux-openmosix/include/hpc/balance.h
--- linux/include/hpc/balance.h	1970-01-01 01:00:00.000000000 +0100
+++ linux-openmosix/include/hpc/balance.h	2004-04-06 21:19:41.000000000 +0200
@@ -0,0 +1,131 @@
+/* Changes since Feb 12, 2002 by Moshe Bar
+ * Copyright (C) 2000, 2001, Amnon Barak (amnon@cs.huji.ac.il)
+ *
+ * Permission to use this software is hereby granted under the terms of the
+ * GNU General Public License, as published by the Free Software Foundation.
+ *
+ * Author(s): Amnon Shiloh, Moshe Bar
+ */
+
+#ifndef _MOSIX_BALANCE_H
+#define _MOSIX_BALANCE_H
+
+#ifdef __KERNEL__
+
+/* various tuning definitions: */
+#define	MAXKNOWNUP		45
+#define INFO_WIN		8
+#define	BALANCING_TIMEOUT	8
+
+struct loadinfo {
+	unsigned short pe;
+	unsigned short speed;	/* in SMP: of each CPU (not the total) */
+	unsigned long load;
+	unsigned short ncpus;
+	unsigned short util;	/* in SMP: max=MF*smp_num_cpus */
+	unsigned short status;
+	unsigned short free_slots;
+	unsigned int mem;
+	unsigned int rmem;
+	unsigned int tmem;
+	unsigned long load_limit; /* CONFIG_MOSIX_LOADLIMIT */
+	unsigned long loadremote; /* estimated totale load of remote processes */
+	unsigned long loadlocal;  /* estimated total load of local processes */
+	unsigned long llimitmode;
+	unsigned long cpu_limit;
+	unsigned long cpuremote;
+	unsigned long cpulocal;
+	unsigned long cpulimitmode;
+#ifdef CONFIG_MOSIX_TOPOLOGY
+	struct opcost costs[MAX_MOSIX_TOPOLOGY];
+	struct mfs_cost mfscosts[MAX_MOSIX_TOPOLOGY];
+#endif /* CONFIG_MOSIX_TOPOLOGY */
+};
+
+struct miginfo {
+	int aload;
+	unsigned long pages;
+	int deppe;
+	int remote;
+};
+
+struct infomsg {
+	long version;
+	int topology;
+	int serialno;
+	struct loadinfo load;
+};
+
+
+/* following is a multiple to be used for statistical values - primarily the
+ * number of system-calls.  Statistical values are counted in chunks of
+ * EVENT_COUNTER_VALUE, rather than simply 1, for the following two reasons:
+ * 1) to prevent being lost by decaying
+ * 2) making the contribution of a system-call to "iocounter" reflect its
+ *    impact, which is considerably more relative to 1-byte of I/O:
+ *    "iocounter" need not be accurate since it is only used to trigger
+ *    considerations for IOBALANCE migrations, but it is good to maintain
+ *    a power of 2 to prevent multiplications in "iocounter" computations.
+ */
+#define	EVENT_COUNTER_VALUE	1024
+#define	EVENT_COUNTER_SHIFT	10
+
+/* MDP constants: */
+#define	KEEP_FREE_PORTION	14	/* 1/16 of memory */
+#define	MAX_PAGES_TO_KEEP_FREE	(0x600000/PAGE_SIZE)	/* but no more than 6MB */
+#define	MIN_EXPECTED_PROC_SIZE	(0x80000/PAGE_SIZE)	/* when freeing memory, at least this */
+#define	MIN_MCHOOSE_AGAIN	1000000	/* youngest (RT) to mconsider */
+#define	MAX_MCHOOSE_AGAIN	4000000	/* no elder-advantage beyond this */
+#define	UTIL_TOLLERANCE		8/10	/* under this, sure trashing */
+#define	OLD_SECONDS		50	/* making an untouched page old changed from 60*/
+
+extern struct loadinfo loadinfo[INFO_WIN];
+
+extern int export_load;		/* load reported to other processors */
+extern int stable_export;	/* machine dependent stabilizing factor */
+extern unsigned acpuse;		/* accumulated cpu utilization */
+extern unsigned coming_in;	/* number of arriving processes */
+extern unsigned came_lately4;	/* processes that arrived lately (*4) */
+extern unsigned load_left;	/* load of processes that just left */
+extern int standard_speed;	/* yardstick */
+extern struct opcost deputy_here[MAX_MOSIX_TOPOLOGY]; /* DEPUTY I/O overheads here */
+extern struct opcost remote_here_adjusted[MAX_MOSIX_TOPOLOGY];
+#ifndef CONFIG_MOSIX_TOPOLOGY
+extern struct opcost remote_here;
+#endif /* CONFIG_MOSIX_TOPOLOGY */
+extern unsigned load_ticks;
+
+extern int pages_to_keep_free;	/* # of pages to attempt to keep free */
+extern int latest_free_mem;	/* in pages */
+
+extern rwlock_t loadinfo_lock;
+
+#define	BUMP_HEAD do { register struct mosix_task *m = &current->mosix; \
+			unsigned long oldcounter; int dobal; \
+			lock_mosix(); \
+			oldcounter = m->iocounter
+
+#define	BUMP_TAIL dobal = ((m->iocounter ^ oldcounter) & 0xfff00000) != 0; \
+			unlock_mosix(); \
+			if(dobal) { mosix_add_to_whereto(current, IOBALANCE); \
+				m->iocounter = 0; } \
+			} while(0)
+
+#define bump_statistics(s) BUMP_HEAD; \
+	m->s += EVENT_COUNTER_VALUE; \
+	m->iocounter += EVENT_COUNTER_VALUE; \
+	BUMP_TAIL
+#define	bump_statistic_amount(type,b) BUMP_HEAD; \
+	m->n##type##s += COPY_COUNTER_MULTIPLIER; \
+	m->type##bytes += b; \
+	m->iocounter += COPY_COUNTER_MULTIPLIER + b; \
+	BUMP_TAIL
+
+#define	bump_copyout(_n)	bump_statistic_amount(copyout,_n)
+#define	bump_copyin(_n)		bump_statistic_amount(copyin,_n)
+#define	bump_syscalls()		bump_statistics(nsyscalls)
+#define	bump_demandpages()	bump_statistics(ndemandpages)
+
+#endif /*__KERNEL__*/
+
+#endif
diff -Naur --exclude=CVS --exclude=configs linux/include/hpc/comm.h linux-openmosix/include/hpc/comm.h
--- linux/include/hpc/comm.h	1970-01-01 01:00:00.000000000 +0100
+++ linux-openmosix/include/hpc/comm.h	2002-06-24 09:22:32.000000000 +0200
@@ -0,0 +1,128 @@
+/*
+ * Copyright (C) 2000, 2001, Amnon Barak (amnon@cs.huji.ac.il)
+ *
+ * Permission to use this software is hereby granted under the terms of the
+ * GNU General Public License, as published by the Free Software Foundation.
+ *
+ * THIS  SOFTWARE  IS  PROVIDED IN ITS  "AS IS"  CONDITION, WITH NO WARRANTY
+ * WHATSOEVER. NO LIABILITY OF ANY KIND FOR ANY DAMAGES WHATSOEVER RESULTING
+ * FROM THE USE OF THIS SOFTWARE WILL BE ACCEPTED.
+ */
+/*
+ * Author(s): Oren Laadan, Amnon Shiloh.
+ */
+
+/* interfacing the MOSIX communication package: */
+
+#ifndef _MOS_COMM_H
+#define _MOS_COMM_H
+
+#ifdef __KERNEL__
+
+struct mosix_link;			/* defined in hpc/comm.c */
+struct mosix_addr;			/* defined in include/hpc/protocol.h */
+struct mosix_task;
+typedef struct mosix_link mosix_link;
+typedef struct mosix_addr mosix_addr;
+
+/*
+ * values for mos# (e.g. in comm_open)
+ * 1..65535	-> valid mos# (mig)
+ * -1..-65535	-> valid mos# (info)
+ */
+
+#define COMM_TOADDR	(70001)
+#define COMM_ACCEPT	(70002)
+#define COMM_MIGD	(70003)
+#define COMM_INFO	(70004)
+#define	COMM_LOOSE	(70005)
+
+/*
+ * message flags:
+ * lower 16 bits used for message types (see hpc/protocol.h)
+ * next 8 bits used for message flags (see below)
+ * upper 8 bits used for mosix logging
+ */
+#define COMM_MFREGS	0x00800000
+#define COMM_MFDATA	0x00400000
+#define COMM_MFIDENT	0x00100000
+#ifdef CONFIG_MOSIX_DFSA
+#define	COMM_MFDFSA	0x00080000
+#define	COMM_MFNODFSA	0x00040000
+#define	COMM_MFDFSAOPTS	(COMM_MFDFSA|COMM_MFNODFSA)
+#endif /* CONFIG_MOSIX_DFSA */
+
+#define COMM_MFOPTIONS	0x00ff0000
+#define	COMM_MFHEADOPTS	(COMM_MFREGS|COMM_MFIDENT)
+
+#define	COMM_ZEROCOPYOK	0x40000000
+
+/*
+ * other flags
+ */
+#define COMM_ALLDATA	(-1)	/* copy/flush all available data */
+
+
+/*
+ * message format
+ */
+struct comm_header {
+	unsigned short olen;
+	unsigned short hlen;
+	int type;
+	int dlen;
+	int regs;
+	int dfsalen;
+};
+
+#define COMM_HLEN	(sizeof(struct comm_header))
+
+/*
+ * exported data
+ */
+extern int comm_type;
+extern unsigned long comm_remote_timo;
+extern unsigned long comm_connect_timo;
+extern unsigned long comm_reconn_timo;
+
+/*
+ * communication module interface
+ */
+
+extern void comm_startup(void);
+extern mosix_link *comm_open(int, mosix_addr *, unsigned long);
+extern mosix_link *comm_use(struct task_struct *, mosix_link *);
+extern void comm_close(mosix_link *);
+extern int comm_accept(mosix_link *,mosix_link **, mosix_addr *,unsigned long);
+extern int comm_send(int, void *, int, void *, int, int);
+extern int comm_recv(void **, int *);
+extern int comm_recvdata(void **);
+extern int comm_copydata(void *, int, int);
+extern int comm_hidedata(void);
+extern void comm_flushdata(int);
+extern void comm_free(void *);
+extern int comm_peek(void);
+extern int comm_wait(void);
+extern int comm_send_urgent(void);
+extern int comm_test_urgent(void);
+extern void comm_take_urgent(void);
+extern int comm_sendto(int, void *, int, mosix_link *, mosix_addr *);
+extern int comm_recvfrom(void *,int, mosix_link *, mosix_addr *, unsigned long);
+extern int comm_recvfrompe(void *,int, mosix_link *, int *, unsigned long);
+extern int net_to_mos(mosix_addr *);
+
+extern inline void comm_invalidate_address(mosix_addr *);
+extern void comm_migration_mode(int);
+extern int comm_getpeer(mosix_link *);
+extern void comm_init_linkpool(void);
+extern void comm_free_linkpool(void);
+extern mosix_link *comm_borrow_linkpool(void);
+extern void comm_return_linkpool(mosix_link *);
+extern void comm_age_linkpool(void);
+extern void rinode_flush_files(int);
+
+extern spinlock_t skown_lock;
+
+#endif /* __KERNEL__ */
+
+#endif
diff -Naur --exclude=CVS --exclude=configs linux/include/hpc/debug.h linux-openmosix/include/hpc/debug.h
--- linux/include/hpc/debug.h	1970-01-01 01:00:00.000000000 +0100
+++ linux-openmosix/include/hpc/debug.h	2004-02-05 02:48:29.000000000 +0100
@@ -0,0 +1,62 @@
+/*
+ * Copyright (C) 2000, 2001, Amnon Barak (amnon@cs.huji.ac.il)
+ *
+ * Permission to use this software is hereby granted under the terms of the
+ * GNU General Public License, as published by the Free Software Foundation.
+ *
+ * THIS  SOFTWARE  IS  PROVIDED IN ITS  "AS IS"  CONDITION, WITH NO WARRANTY
+ * WHATSOEVER. NO LIABILITY OF ANY KIND FOR ANY DAMAGES WHATSOEVER RESULTING
+ * FROM THE USE OF THIS SOFTWARE WILL BE ACCEPTED.
+ */
+/*
+ * Author(s): Amnon Shiloh, Oren Laadan.
+ */
+
+#ifndef _MOS_DEBUG_H
+#define _MOS_DEBUG_H
+
+#ifdef CONFIG_MOSIX_DEBUG
+
+extern unsigned long ds_debug;
+
+#define DSDEB_ERROR	0x00000001
+#ifdef CONFIG_MOSIX_DFSA
+#define	DSDEB_DFSA	0x00000002
+#endif /* CONFIG_MOSIX_DFSA */
+#define DSDEB_MIG	0x00000010
+#define	DSDEB_EXPEL	0x00000020
+#define	DSDEB_HOLD	0x00000040
+#define	DSDEB_MIGSTAGE	0x00000080
+#define DSDEB_WHERETO	0x00000100
+#define DSDEB_INFO	0x00000200
+#define DSDEB_PROC	0x00000400
+#define	DSDEB_CACHE	0x00000800
+#define	DSDEB_CACHESTOP 0x00001000
+#define DSDEB_CONFIG	0x00002000
+#define	DSDEB_LOAD	0x00004000
+#define	DSDEB_CONSIDER	0x00008000
+#define	DSDEB_LOADS	0x00010000
+#define	DSDEB_ANCESSTOR	0x00020000
+#define	DSDEB_DECAY	0x00040000
+#define	DSDEB_MEM	0x00080000
+#define	DSDEB_NOTCACHED	0x00100000
+#define	DSDEB_SUPERMEM	0x00200000
+
+#define DSDEB_COMMOPEN	0x00400000
+#define DSDEB_COMMACPT	0x00800000
+#define DSDEB_COMMFLAGS	0x01000000
+#define DSDEB_COMMRECV	0x02000000
+#define DSDEB_COMMSEND	0x04000000
+#define DSDEB_COMMADDR	0x08000000
+#define	DSDEB_COMMDORECV 0x10000000
+#define	DSDEB_COMMDOSEND 0x20000000
+#define	DSDEB_DEBUGSEND	0x40000000
+
+
+#define DSDEB_COMM	(DSDEB_COMMOPEN|DSDEB_COMMACPT|DSDEB_COMMFLAGS|	\
+			 DSDEB_COMMRECV|DSDEB_COMMSEND|DSDEB_COMMADDR)
+
+#endif /* CONFIG_MOSIX_DEBUG */
+
+#define mosix_panic	panic
+#endif
